#ifndef __UTILS_H__
#define __UTILS_H__

#include <stdio.h>
#include <stdint.h>

extern int get_uint8(const unsigned char *data, size_t *offset, size_t size, uint8_t *value);
extern int get_uint16(const unsigned char *data, size_t *offset, size_t size, uint16_t *value);
extern int get_uint32(const unsigned char *data, size_t *offset, size_t size, uint32_t *value);
extern int get_string(const unsigned char *data, size_t *offset, size_t size, char **value, size_t len);
extern int write_uint8(FILE *fp, uint8_t value);
extern int write_uint16(FILE *fp, uint16_t value);
extern int write_uint32(FILE *fp, uint32_t value);
extern int write_buffer(FILE *fp, const unsigned char *buffer, size_t size);
extern int make_directory(const char *path, int path_is_file);
extern void convert_slash_to_backslash(char *str);
extern void convert_backslash_to_slash(char *str);
extern char *create_new_filename(const char *filename);
extern int read_file(const char *filename, unsigned char **data, size_t *size);
extern int write_file(const char *filename, const unsigned char *data, size_t size);

#endif	/* __UTILS_H__ */
